Description

Currently an AJAX Widget stores the WidgetContext in the WidgetContextHolder which again puts it in the current user session.
This should be configurable so that the context can be passed to the target widget action via GET/POST.
Note: This requires that the request handler verifies the HMAC of the widget request!

Associated revisions
Revision 2db35873 - 2011-11-10 15:07 - Bastian Waidelich

[FEATURE] (Core): Stateless AJAX Widgets

Currently an AJAX Widget stores the WidgetContext in the
WidgetContextHolder which again puts it in the current user
session.
This change adds a property "stateless" to the
AbstractWidgetViewHelper. If that's TRUE, the widget context
won't be stored in the session anymore. Instead, the
WidgetRequestBuilder then expects the "internal argument" 
__widgetContext to be specified (with a valid HMAC appended).

The Widget Link/Uri-Viewhelpers now add the serialized and
HMAC'ed WidgetContext to the generated URI if the new argument
"includeWidgetContext" is set.

Besides this change renames the widgetId argument from
"typo3-fluid-widget-id" to "__widgetId" as discussed.
Note: This would be a breaking change, if you relied on that
specific GET argument (which is however very unlikely)!

Lastly the WidgetRequestBuilder now interprets merged GET + POST
arguments instead of relying on GET only. This makes it possible
to pass the widgetId/Context via POST.

Change-Id: I3d4e06a1823786f23fc7ce5ef0b179d625abccff
Resolves: #31167
Release: 1.1

History
#1 - 2011-11-09 15:21 - Mr. Hudson

Patch set 1 of change I3d4e06a1823786f23fc7ce5ef0b179d625abccff has been pushed to the review server.
It is available at http://review.typo3.org/6611
#2 - 2011-11-10 14:54 - Mr. Hudson

Patch set 2 of change I3d4e06a1823786f23fc7ce5ef0b179d625abccff has been pushed to the review server.
It is available at http://review.typo3.org/6611

#3 - 2011-11-10 15:07 - Mr. Hudson

Patch set 3 of change I3d4e06a1823786f23fc7ce5ef0b179d625abccff has been pushed to the review server.
It is available at http://review.typo3.org/6611

#4 - 2011-11-10 17:36 - Bastian Waidelich
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:2db358732b01c977b9c5709b772601ab483129e6.
